// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include "utility.h"
#include "Dal.h"
#include <cstring>
#include<iostream>
#include <sstream>
#include<fstream>
#include <cmath>
bool getWindowParameters( string fileName, windowParameters &parameters) 
{






  
    DataSet *dataSet = dataSetServer->open(fileName, Dal::Read);
    if (!dataSet) return false;


    int windowX0 = dataSet->attribute("WINDOWX0")->asInt();
    int windowY0 = dataSet->attribute("WINDOWY0")->asInt();


    int xBin = dataSet->attribute("BINAX1")->asInt();
    int yBin = dataSet->attribute("BINAX2")->asInt();




    bool binBPE = dataSet->attribute( "BINBPE" )->asBool();


    xBin = (int)pow(2.0, xBin);
    yBin = (int)pow(2.0, yBin);


    if (binBPE) 
    {
        xBin *= 2;
        yBin *= 2;
    }




    dataSetServer->close(dataSet); // Finished with the file


  
 

    windowX0 *= xBin;
    windowY0 *= yBin;

    parameters.x0 = windowX0;
    parameters.y0 = windowY0;
    parameters.xBin = xBin;
    parameters.yBin = yBin;



    return true;

}





/*******************************************************************
*
*******************************************************************/
double distance(double r1, double d1, double r2, double d2)
{



    return acos( sin(d1) * sin(d2) + cos(d1) * cos(d2) 
	            * cos(r1 - r2) ) * radiansToArcSecs; 


};

bool isNull( float value)
{

   
    char text[20];

    sprintf(text, "%f", value);

    if (strncmp( text, "nan", 3) == 0 || 
        strncmp( text, "NAN", 3) == 0)
        return true;
    else
        return false;    


}

bool isNull( double value)
{

   
    char text[20];

    sprintf(text, "%f", value);

    if (strncmp( text, "nan", 3) == 0 || 
        strncmp( text, "NAN", 3) == 0)
        return true;
    else
        return false;    


}

bool isNull( int value)
{

   
    char text[20];

    sprintf(text, "%d", value);

    if (strncmp( text, "nan", 3) == 0 || 
        strncmp( text, "NAN", 3) == 0)
        return true;
    else
        return false;    


}













